Attribute VB_Name = "mReg"
'============================================================================
' CopyRight(c) 1999-2002 Da Silva Serge
'============================================================================
Option Explicit

' Reg Key ROOT Types...
Enum HK_KEYROOT
    HKEY_CLASSES_ROOT& = &H80000000
    HKEY_CURRENT_USER& = &H80000001
    HKEY_LOCAL_MACHINE& = &H80000002
    HKEY_USERS& = &H80000003
End Enum

' WIN API
'Registry operation
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExInt Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExByte Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValueExLng Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal reserved As Long, ByVal dwType As Long, lData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExStr Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal reserved As Long, ByVal dwType As Long, ByVal szData As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExByte Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal reserved As Long, ByVal dwType As Long, bData As Byte, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long
Private Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumValueLong Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegEnumValueStr Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegEnumValueByte Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Const ERROR_SUCCESS = 0&
Private Const ERROR_ACCESS_DENIED = 5&
Private Const ERROR_NOT_EXIST = 2&
Private Const ERROR_MOREDATA = 234&
Private Const ERROR_NO_MOREITEMS& = 259&

Private Const REG_NONE = 0                           ' No value type
Private Const REG_SZ = 1                             ' Unicode nul terminated string
Private Const REG_EXPAND_SZ = 2                      ' Unicode nul terminated string
Private Const REG_BINARY = 3                         ' Free form binary
Private Const REG_DWORD = 4                          ' 32-bit number
Private Const REG_DWORD_LITTLE_ENDIAN = 4            ' 32-bit number (same as REG_DWORD)
Private Const REG_DWORD_BIG_ENDIAN = 5               ' 32-bit number
Private Const REG_LINK = 6                           ' Symbolic Link (unicode)
Private Const REG_MULTI_SZ = 7                       ' Multiple Unicode strings
Private Const REG_RESOURCE_LIST = 8                  ' Resource list in the resource map
Private Const REG_FULL_RESOURCE_DESCRIPTOR = 9       ' Resource list in the hardware description
Private Const REG_RESOURCE_REQUIREMENTS_LIST = 10

Private Const CMAXPATH& = 260

Private Const REG_OPTION_NON_VOLATILE = 0       ' Key is preserved when system is rebooted

Private Const SYNCHRONIZE = &H100000
Private Const READ_CONTROL = &H20000
Private Const READ_WRITE = 2

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)

Private Const KEY_CREATE_LINK = &H20
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_EVENT = &H1     '  Event contains key event record
Private Const KEY_SET_VALUE = &H2
Private Const KEY_NOTIFY = &H10
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const KEY_EXECUTE = (KEY_READ)
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))

Function RegCreateSection(Optional ByVal strSection As String, _
                          Optional ByVal hKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean

    Dim lResult         As Long
    Dim lDisposition    As Long
    Dim lpSecAttrib     As SECURITY_ATTRIBUTES

    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    RegCreateSection = RegCreateKeyEx(hKeyRoot, _
                                      strSection, _
                                      0&, _
                                      vbNullString, _
                                      REG_OPTION_NON_VOLATILE, _
                                      KEY_ALL_ACCESS, _
                                      lpSecAttrib, _
                                      lResult, _
                                      lDisposition) = 0

End Function

Function RegDelSection(ByVal strSection As String, _
                       Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean
    
    Dim lRc         As Long
    Dim strSKey     As String
    Dim lhSubKey    As Long

    ' Supposons un succs
    RegDelSection = True
    ' Essayer de supprimer l'ensemble--marche toujous avec Win95, mais choue
    ' pour des cls aves sous-cls en WinNT
    lRc = RegDeleteKey(lhKeyRoot, strSection)
    If (lRc <> ERROR_SUCCESS) And (lRc <> ERROR_NOT_EXIST) Then
        'Ouverture de la section registre
        lRc = RegOpenKeyEx(lhKeyRoot, strSection, 0, KEY_ALL_ACCESS, lhSubKey)
        If (lRc = ERROR_SUCCESS) Then
            Do While (lRc = ERROR_SUCCESS)
                strSKey = String$(CMAXPATH, 0)
                lRc = RegEnumKey(lhSubKey, 0, strSKey, Len(strSKey))
                'Suppression du vbnullchar
                strSKey = pStrZToStr(strSKey)
                If lRc = ERROR_SUCCESS Then
                    If RegDelSection(strSection & "\" & strSKey, lhKeyRoot) Then
                        lRc = ERROR_SUCCESS
                    Else
                        lRc = ERROR_ACCESS_DENIED
                    End If
                End If
            Loop
        End If
        ' Essayer de nouveau de supprimer la racine
        RegDelSection = (RegDeleteKey(lhKeyRoot, strSection) = ERROR_SUCCESS)
    End If
    
End Function

Function RegDelValue(ByVal strKey As String, _
                     ByVal strSection As String, _
                     Optional ByVal hKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean
    
    Dim lhKey   As Long
    Dim lRc     As Long

    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    lRc = RegOpenKey(hKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        lRc = RegDeleteValue(lhKey, strKey)
        RegDelValue = (lRc = ERROR_SUCCESS)
        lRc = RegCloseKey(lhKey)
    End If
    
End Function

Function RegGetBytes(ByVal strKey As String, _
                     ByRef ab() As Byte, _
                     ByVal strSection As String, _
                     Optional ByVal hKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Long
    
    Dim lRc         As Long
    Dim lType       As Long
    Dim lhKey       As Long
    Dim lValSize    As Long
    Dim lpReserved  As Long
    
    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    'Ouverture de la section, recuperation du handle
    lRc = RegOpenKey(hKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        'Ouverture de la cl, recuperation du type de valeur
        lRc = RegQueryValueEx(lhKey, strKey, ByVal lpReserved, lType, 0&, lValSize)
        'Verification du type de la valeur
        If (lRc = ERROR_MOREDATA Or lRc = ERROR_SUCCESS) And _
           (lType = REG_BINARY) And _
           (lValSize > 0) Then
                    
            ReDim ab(lValSize) As Byte
            'Recuperation de la valeur
            lRc = RegQueryValueExByte(lhKey, strKey, ByVal lpReserved, lType, ab(0), lValSize)
        End If
        'Retour du resultat
        If (lRc = ERROR_SUCCESS) And (lValSize > 1) Then
            lValSize = lValSize - 1
            ReDim Preserve ab(lValSize) As Byte
            RegGetBytes = lValSize
        End If
        'Fermeture de la cl et liberation du handle
        lRc = RegCloseKey(lhKey)
    End If
    
End Function

Function RegGetLong(ByVal strKey As String, _
                    ByRef lValue As Long, _
                    ByVal strSection As String, _
                    Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean
    
    Dim lRc         As Long
    Dim lType       As Long
    Dim lhKey       As Long
    Dim lValSize    As Long
    Dim lVal        As Long
    Dim lpReserved  As Long
    
    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    'Ouverture de la section, recuperation du handle
    lRc = RegOpenKey(lhKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        'Ouverture de la cl, recuperation du type de valeur
        lRc = RegQueryValueEx(lhKey, strKey, ByVal lpReserved, lType, 0&, lValSize)
        'Verification du type de la valeur
        If (lRc = ERROR_MOREDATA Or lRc = ERROR_SUCCESS) And _
           (lType = REG_DWORD) Then
                    
            'Recuperation de la valeur
            lRc = RegQueryValueExInt(lhKey, strKey, ByVal lpReserved, lType, lVal, lValSize)
            'Renvoi de la valeur
            If lRc = ERROR_SUCCESS Then
                lValue = lVal
                RegGetLong = True
            End If
        End If
        'Fermeture de la cl et liberation du handle
        lRc = RegCloseKey(lhKey)
    End If
    
End Function

Function RegKeyExist(ByVal strSection As String, Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean

    Dim lRc         As Long
    Dim lhKey       As Long
    
    'Ouverture de la section, recuperation du handle
    lRc = RegOpenKey(lhKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        RegKeyExist = True
    End If
    
End Function
    
Function RegGetStr(ByVal strKey As String, _
                   ByRef strValue As String, _
                   ByVal strSection As String, _
                   Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Long
    
    Dim lRc         As Long
    Dim lType       As Long
    Dim lhKey       As Long
    Dim lValSize    As Long
    Dim strVal      As String
    Dim lpReserved  As Long
    
    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    'Ouverture de la section, recuperation du handle
    lRc = RegOpenKey(lhKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        'Ouverture de la cl, recuperation du type de valeur
        lRc = RegQueryValueEx(lhKey, strKey, ByVal lpReserved, lType, 0&, lValSize)
        'Verification du type de la valeur
        If (lRc = ERROR_MOREDATA Or lRc = ERROR_SUCCESS) And _
           (lType = REG_SZ Or lType = REG_EXPAND_SZ) And _
           (lValSize > 0) Then
                   
            'Recuperation de la valeur
            strVal = String$(lValSize, 0)
            lRc = RegQueryValueEx(lhKey, strKey, ByVal lpReserved, REG_SZ, ByVal strVal, lValSize)
        End If
        'Fermeture de la cl
        Call RegCloseKey(lhKey)
        'Retour du resultat
        If lRc = ERROR_SUCCESS Then
'        If lRc = ERROR_SUCCESS And (lValSize > 0) Then
            'Suppression du vbnullchar
            strValue = pStrZToStr(strVal)
            'Retour du succes
            RegGetStr = Len(strValue)
        End If
    End If
    
End Function

Function RegSetBytes(ByVal strKey As String, _
                     ByRef bVal() As Byte, _
                     ByVal strSection As String, _
                     Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean
    
    Dim lhKey   As Long
    Dim lVal    As Long
    Dim lRc     As Long
    Dim lpReserved  As Long

    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    lRc = RegCreateKey(lhKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        lVal = UBound(bVal) + 1
        lRc = RegSetValueExByte(lhKey, strKey, ByVal lpReserved, REG_BINARY, bVal(0), ByVal lVal)
        RegSetBytes = (lRc = ERROR_SUCCESS)
        lRc = RegCloseKey(lhKey)
    End If
    
End Function

Function RegSetLong(ByVal strKey As String, _
                    ByVal lValue As Long, _
                    ByVal strSection As String, _
                    Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean

    Dim lhKey        As Long
    Dim lpReserved  As Long
    Dim lRc         As Long

    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If Right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    lRc = RegCreateKey(lhKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        lRc = RegSetValueExLng(lhKey, strKey, ByVal lpReserved, REG_DWORD, lValue, 4)
        RegSetLong = (lRc = ERROR_SUCCESS)
        lRc = RegCloseKey(lhKey)
    End If
    
End Function

Function RegSetStr(ByVal strKey As String, _
                   ByVal strValue As String, _
                   ByVal strSection As String, _
                   Optional ByVal lhKeyRoot As HK_KEYROOT = HKEY_CURRENT_USER) As Boolean
                
    Dim lhKey    As Long
    Dim lRc     As Long
    Dim lValue  As Long

    ' -----------------------------------------------
    ' Ne fonctionne pas sous win95
    'If right$(strSection, 1) <> "\" Then strSection = strSection & "\"
    ' -----------------------------------------------
    
    'Ouverture de la section
    lRc = RegCreateKey(lhKeyRoot, strSection, lhKey)
    If lRc = ERROR_SUCCESS Then
        ' Ajout d'un null char
        strValue = pStrToStrZ(strValue)
        'Calcul de la longeur de la data
        lValue = Len(strValue)
        lRc = RegSetValueExStr(lhKey, strKey, 0&, REG_SZ, strValue, lValue)
        RegSetStr = (lRc = ERROR_SUCCESS)
        'Fermeture de la section
        lRc = RegCloseKey(lhKey)
    End If
                
End Function

'Retourne les caracteres avant qu'un caractere null soit rencontre
Private Function pStrZToStr(ByVal strZ As String) As String
    If InStr(strZ, vbNullChar) Then
        pStrZToStr = Left$(strZ, InStr(strZ, vbNullChar) - 1)
    Else
        pStrZToStr = strZ
    End If
End Function

Private Function pStrToStrZ(ByVal str As String) As String
    If InStr(str, vbNullChar) = 0 Then
        pStrToStrZ = str & vbNullChar
    Else
        pStrToStrZ = str
    End If
End Function

